﻿--[[
	Persistent Data for RaidTracker, Saved Variables	
]]


KarmaLibrary = {
	
}

function KarmaLibrary:GetInstance( inst, name )
	inst = inst or { } 
	
	inst._instance = {
		name = name,
		instance = inst,
		libData = KarmaData,
		libUtility = KarmaUtility,
		libLibrary = KarmaLibrary,
	}
	
	inst._metadata = {
		version = GetAddOnMetadata("RaidTracker","Version"), 
		title = GetAddOnMetadata("RaidTracker","Title"),
		author = GetAddOnMetadata("RaidTracker","Author"),
	}
		
	local _inst = inst._instance
	setmetatable( _inst.libUtility, { __index = _inst.libData } );
	setmetatable( _inst.libLibrary, { __index = _inst.libUtility } );
	setmetatable( inst, { __index = _inst.libLibrary } );
	
	return inst;
end


function KarmaLibrary:OnEvent( event )
	if event == "VARIABLES_LOADED" then
        self:Debug("KarmaLibrary:OnEvent - VARIABLES_LOADED");
		if self._DataOnVariablesLoaded then self:_DataOnVariablesLoaded() end
		if self.OnVariablesLoaded then self:OnVariablesLoaded() end
	elseif event == "UPDATE_MOUSEOVER_UNIT"	then
		if self.OnUpdateMouse then self:OnUpdateMouse() end
	else	
		if self.OnEventCustom then self:OnEventCustom( event ) end
	end
end
